/*	lemon_board Copyright (C) 2022 Wael Karram.
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU Affero General Public License as published by
*	the Free Software Foundation, version 3 of the License.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU Affero General Public License for more details.
*
*	You should have received a copy of the GNU Affero General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Include guard. */
#ifndef BOARD_STRUCT
#define BOARD_STRUCT

/* Include thread.h */
#include "thread.h"

/* Define data structures. */
/* This struct is used to store a single board. */
typedef struct Board {
	/* Set board name, has to be unique! */
	char *board_name;
	/* Set threads array. */
	thread_t **thread_array;
	/* Set the number of thread. */
	size_t threads;
	/* Flag to set if the board is listed or not. */
	int listed;
} board_t;

#endif	/* BOARD_STRUCT */
