/*	lemon_board Copyright (C) 2022 Wael Karram.
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU Affero General Public License as published by
*	the Free Software Foundation, version 3 of the License.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU Affero General Public License for more details.
*
*	You should have received a copy of the GNU Affero General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Include guard. */
#ifndef FLAT_FILE_UTILS_H
#define FLAT_FILE_UTILS_H

/* Include locale.h for setting the locale. */
#include <locale.h>

/* Include stdio.h for file I/O. */
#include <stdio.h>

/* Set debug if needed. */
#ifdef DEBUG
#ifndef NDEBUG
#define NDEBUG
#endif /* NDEBUG */
#endif /* DEBUG */
/* Include assert.h to allow code generation. */
#include <assert.h>

/* Define the locale. */
#define LOCALE_EN_US_UTF8_FLAT_FILE_UTILS_H		"en_US.UTF-8"
/* Define file r/w modes. */
#define FILE_READ_ONLY_FLAT_FILE_UTILS_H		"r"
#define FILE_READ_WRITE_FLAT_FILE_UTILS_H		"w+"
#define FILE_APPEND_ONLY_FLAT_FILE_UTILS_H		"a"
/* Define return codes. */
#define WRITE_SUCCESS_FLAT_FILE_UTILS_H			0
#define OPEN_ERROR_FLAT_FILE_UTILS_H			1

/* Function declarations. */
/* This function attempts to open and read a file. */
static inline char *read_file(const char *restrict pathname, size_t *length);
/* This function attempts to open/create and write to a file. */
static inline int write_to_file(const char *restrict pathname, const char *restrict string);
/* This function attempts to open/create and append to a file. */
static inline int append_to_file(const char *restrict pathname, const char *restrict string);

#endif	/* FLAT_FILE_UTILS_H */
