/*	lemon_board Copyright (C) 2022 Wael Karram.
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU Affero General Public License as published by
*	the Free Software Foundation, version 3 of the License.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU Affero General Public License for more details.
*
*	You should have received a copy of the GNU Affero General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Include guard. */
#ifndef INDEX_STRUCT
#define INDEX_STRUCT

/* Include board.h */
#include "board.h"

/* Define data structures. */
/* This struct is used to store a single index. */
typedef struct Index {
	/* Set index name, has to be unique! */
	char *index_name;
	/* Set boards array. */
	board_t **board_array;
	/* Set the number of boards. */
	size_t boards;
} index_t;

#endif	/* INDEX_STRUCT */
