/*	lemon_board Copyright (C) 2022 Wael Karram.
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU Affero General Public License as published by
*	the Free Software Foundation, version 3 of the License.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU Affero General Public License for more details.
*
*	You should have received a copy of the GNU Affero General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Include guard. */
#ifndef THREAD_STRUCT
#define THREAD_STRUCT

/* Include post.h */
#include "post.h"

/* Include useful functions from C_lib for string processing. */
/* Include C_lib's strscpy. */
#include "../C_lib/strings/strscpy.h"
/* Include C_lib's strcatarr. */
#include "../C_lib/strings/strcatarr.h"
/* Use the linked list data structure from C_lib. */
#include "../C_lib/linked_lists/single_linked_list.h"

/* Define constants. */
#define THREAD_STRUCT_NULL_CHAR				'\0'
#define THREAD_STRUCT_POST_SEPARATOR_STRING_LENGTH	2L /* Account for NULL-terminator. */
#define THREAD_STRUCT_POST_SEPARATOR_CHAR		'~' /* For splitting using strchr. */
/* Variable constants. */
const char* THREAD_STRUCT_POST_SEPARATOR_STRING	= 	"~";

/* Define data structures. */
/* This struct is used to store a single thread. */
typedef struct Thread {
	/* Set OP. */
	post_t *original_post;
	/* Set array of posts. */
	post_t **posts;
	/* Set number of replies. */
	size_t replies;
} thread_t;

/* Define a serialization function. */
static inline char *serialize_thread(thread_t *thread);
/* Define a generation/deserialization function, modifies the input buffer!! */
static inline thread_t *deserialize_thread(char *text);

#endif	/* THREAD_STRUCT */
