/*	lemon_board Copyright (C) 2022 Wael Karram.
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU Affero General Public License as published by
*	the Free Software Foundation, version 3 of the License.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU Affero General Public License for more details.
*
*	You should have received a copy of the GNU Affero General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* Include guard. */
#ifndef STRING_UTIL_H
#define STRING_UTIL_H

/* Include limits.h to calculate lengths. */
#include <limits.h>

/* Include stdio.h to use in the conversion. */
#include <stdio.h>

/* Include string.h and math.h for calculating lengths. */
#include <string.h>
#include <math.h>

/* Setup debug if needed. */
#ifdef DEBUG
#ifndef NDEBUG
#define NDEBUG
#endif /* NDEBUG */
#endif /* DEBUG */
/* Include assert.h to allow code generation. */
#include <assert.h>

/* Conversion constant string. */
#define CONVERSION_FORMAT_STRING_UTIL_H		"%lld";

/* Function declarations. */
/* This function is used to calculate the string length for a given value. */
static inline size_t ulltostrlen(const unsigned long long value);
/* This function allocates a string with the value stored in it. */
static inline char *ulltostr(const unsigned long long value);

#endif	/* STRING_UTIL_H */
